package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.HashMap;
import java.util.Map;

import javax.sql.DataSource;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Datebox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioObservacaoEventosFinanceiros;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

@Scope("prototype")
@Controller("relatorioObservacaoEventosFinanceirosController")
public class RelatorioObservacaoEventosFinaneirosController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	
	private static Logger log = LogManager.getLogger(RelatorioObservacaoEventosFinaneirosController.class);
	
	@Autowired
	private DataSource dataSourceRead;

	private Datebox dataInicial;
	private Datebox dataFinal;
	
    private PuntoVenta puntoVenta;
    private Empresa empresa; 
    
    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
    }
    
    public void onClick$btnRelatorio(Event ev) {
    	try {
    		Map<String, Object> parametros = new HashMap<String, Object>();
        	parametros.put("empresaId", empresa.getEmpresaId());
        	parametros.put("empresa", empresa.getNombempresa());
        	parametros.put("usuario", UsuarioLogado.getUsuarioLogado().getNombmaterno());
        	parametros.put("fecInicio", DateUtil.getStringDate(dataInicial.getValue(), "dd/MM/yyyy"));
    		parametros.put("fecFinal", DateUtil.getStringDate(dataFinal.getValue(), "dd/MM/yyyy"));
    		parametros.put("dataFiltroInicial", dataInicial.getValue());
    		parametros.put("dataFiltroFinal", dataFinal.getValue());

    		if(puntoVenta != null) {
    			parametros.put("puntoventaId", puntoVenta.getPuntoventaId());
    			parametros.put("puntoventa", puntoVenta.getNombpuntoventa());
    		} else {
    			parametros.put("puntoventa", "Todos");
    		}
        	
    		Relatorio relatorio =  new RelatorioObservacaoEventosFinanceiros(parametros, dataSourceRead.getConnection()); 
        	
        	Map<String, Object> args = new HashMap<String, Object>();
    		args.put("relatorio", relatorio);

    		openWindow("/component/reportView.zul",
    				   Labels.getLabel("relatorioObservacaoEventosFinanceirosController.window.title"), args, MODAL);			
		} catch (Exception e) {
			log.error(e.getMessage(), e);
		}
    }

	public PuntoVenta getPuntoVenta() {
		return puntoVenta;
	}

	public void setPuntoVenta(PuntoVenta puntoVenta) {
		this.puntoVenta = puntoVenta;
	}

	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}

}
